openapi: 3.0.1
info:
  title: Ensi PIM.
  contact:
    url: https://greensight.ru/
  version: 1.0.0
  description: PIM
servers:
  - url: /api/v1
tags:
  - name: products
    description: Products
  - name: product-groups
    description: Product groups
  - name: categories
    description: Categories
  - name: properties
    description: Properties
  - name: brands
    description: Brands
  - name: product-fields
    description: Product fields
  - name: product-statuses
    description: Product statuses
  - name: product-flags
    description: Product flags
  - name: product-events
    description: Product events
  - name: search
    description: Search
  - name: imports
    description: Imports
  - name: common
    description: Common
  - name: temp-files
    description: Temp files
paths:
  /classifiers/product-fields:search:
    $ref: './classifiers/paths.yaml#/ProductFieldsSearch'
  /classifiers/product-fields/{id}:
    $ref: './classifiers/paths.yaml#/ProductFieldsCurrent'
  /classifiers/product-flags:search:
    $ref: './classifiers/paths.yaml#/ProductFlagsSearch'
  /classifiers/product-flags/{id}:
    $ref: './classifiers/paths.yaml#/ProductFlagsCurrent'

  /classifiers/product-statuses:next:
    $ref: './classifiers/paths.yaml#/ProductStatusesNext'
  /classifiers/product-statuses/{id}:set-previous:
    $ref: './classifiers/paths.yaml#/ProductStatusesSetPrevious'

  /classifiers/product-statuses:search:
    $ref: './classifiers/paths.yaml#/ProductStatusSettingsSearch'
  /classifiers/product-statuses:
    $ref: './classifiers/paths.yaml#/ProductStatusSettings'
  /classifiers/product-statuses/{id}:
    $ref: './classifiers/paths.yaml#/ProductStatusSettingsOne'

  /products/products:search:
    $ref: './products/paths.yaml#/ProductDraftsSearch'
  /products/products:preload-image:
    $ref: './products/paths.yaml#/ProductsPreloadImage'
  /products/products:
    $ref: './products/paths.yaml#/ProductsCreate'
  /products/products:mass-delete:
    $ref: './products/paths.yaml#/ProductsMassDelete'
  /products/products:mass-patch:
    $ref: './products/paths.yaml#/ProductsMassPatch'
  /products/products:mass-patch-by-query:
    $ref: './products/paths.yaml#/ProductsMassPatchByQuery'
  /products/products:common-attributes:
    $ref: './products/paths.yaml#/ProductsCommonAttributes'

  /products/products/{id}:
    $ref: './products/paths.yaml#/ProductsCurrent'
  /products/products/{id}/images:
    $ref: './products/paths.yaml#/ProductImagesEdit'
  /products/products/{id}:upload-image:
    $ref: './products/paths.yaml#/ProductImageUpload'
  /products/products/{id}:delete-image:
    $ref: './products/paths.yaml#/ProductImageDelete'
  /products/products/{id}/attributes:
    $ref: './products/paths.yaml#/ProductAttributesEdit'

  /products/published:search:
    $ref: './products/paths.yaml#/PublishedProductsSearch'
  /products/published/{id}:
    $ref: './products/paths.yaml#/PublishedProductsCurrent'

  /products/product-groups:
    $ref: './products/paths.yaml#/ProductGroups'
  /products/product-groups/{id}:
    $ref: './products/paths.yaml#/ProductGroupsCurrent'
  /products/product-groups/{id}:bind-products:
    $ref: './products/paths.yaml#/ProductGroupsCurrentBindProducts'
  /products/product-groups:mass-delete:
    $ref: './products/paths.yaml#/ProductGroupsMassDelete'
  /products/product-groups:search:
    $ref: './products/paths.yaml#/ProductGroupsSearch'
  /products/product-groups:search-one:
    $ref: './products/paths.yaml#/ProductGroupsSearchOne'

  /products/product-events:search:
    $ref: './products/paths.yaml#/ProductEventsSearch'

  /categories/categories:
    $ref: './categories/paths.yaml#/Categories'
  /categories/categories/{id}:
    $ref: './categories/paths.yaml#/CategoriesCurrent'
  /categories/categories/{id}:bind-properties:
    $ref: './categories/paths.yaml#/CategoriesCurrentBindProperties'
  /categories/categories:mass-delete:
    $ref: './categories/paths.yaml#/CategoriesMassDelete'
  /categories/categories:search:
    $ref: './categories/paths.yaml#/CategoriesSearch'
  /categories/categories:tree:
    $ref: './categories/paths.yaml#/CategoriesTree'
  /categories/categories:actualize:
    $ref: './categories/paths.yaml#/ActualizeCategories'

  /categories/actual-category-properties:search:
    $ref: './categories/paths.yaml#/ActualCategoryPropertiesSearch'

  /categories/properties:
    $ref: './categories/paths.yaml#/Properties'
  /categories/properties/{id}:
    $ref: './categories/paths.yaml#/PropertiesCurrent'
  /categories/properties:mass-delete:
    $ref: './categories/paths.yaml#/PropertiesMassDelete'
  /categories/properties:search:
    $ref: './categories/paths.yaml#/PropertiesSearch'

  /categories/properties/{id}:add-directory:
    $ref: './categories/paths.yaml#/PropertiesCurrentAddDirectory'
  /categories/properties/{id}:add-directories:
    $ref: './categories/paths.yaml#/PropertiesCurrentAddDirectories'
  /categories/properties/directory:preload-image:
    $ref: './categories/paths.yaml#/PropertiesDirectoryPreloadImage'
  /categories/properties/directory:preload-file:
    $ref: './categories/paths.yaml#/PropertiesDirectoryPreloadFile'
  /categories/properties/directory/{id}:
    $ref: './categories/paths.yaml#/PropertiesDirectoryCurrent'
  /categories/properties/directory:search:
    $ref: './categories/paths.yaml#/PropertiesDirectorySearch'

  /classifiers/brands:
    $ref: './classifiers/paths.yaml#/BrandsCreate'
  /classifiers/brands/{id}:
    $ref: './classifiers/paths.yaml#/BrandsCurrent'
  /classifiers/brands:search:
    $ref: './classifiers/paths.yaml#/BrandsSearch'
  /classifiers/brands:mass-delete:
    $ref: './classifiers/paths.yaml#/BrandsMassDelete'
  /classifiers/brands/{id}:upload-image:
    $ref: './classifiers/paths.yaml#/BrandsUploadImage'
  /classifiers/brands/{id}:delete-image:
    $ref: './classifiers/paths.yaml#/BrandsDeleteImage'
  /classifiers/brands:preload-image:
    $ref: './classifiers/paths.yaml#/PreloadImage'

  /imports/products:
    $ref: './imports/paths.yaml#/ProductsImportsCreate'
  /imports/products:preload-file:
    $ref: './imports/paths.yaml#/ProductImportsPreloadFile'
  /imports/products/{id}:
    $ref: './imports/paths.yaml#/ProductImportsOne'
  /imports/products:search:
    $ref: './imports/paths.yaml#/ProductImportsSearch'
  /imports/product-warnings:search:
    $ref: './imports/paths.yaml#/ProductImportWarningsSearch'

  /support/temp-files:search:
    $ref: './support/paths.yaml#/TempFilesSearch'
  /common/bulk-operations:search:
    $ref: './common/paths.yaml#/BulkOperationsSearch'
  /common/failed-jobs:search:
    $ref: './common/paths.yaml#/FailedJobsSearch'

components:
  parameters:
    QueryInclude:
      $ref: './common_parameters.yaml#/QueryInclude'
    PathId:
      $ref: './common_parameters.yaml#/PathId'

  requestBodies:
    MassDeleteBody:
      required: true
      content:
        application/json:
          schema:
            $ref: './common_schemas.yaml#/RequestBodyMassOperation'

  schemas:
    PaginationTypeEnum:
      $ref: './common_schemas.yaml#/PaginationTypeEnum'
    PropertyTypeEnum:
      $ref: './categories/enums/property_type_enum.yaml'
    ProductSystemStatusEnum:
      $ref: './products/enums/product_system_status_enum.yaml'
    ProductTypeEnum:
      $ref: './products/enums/product_type_enum.yaml'
    ProductUomEnum:
      $ref: './products/enums/product_uom_enum.yaml'
    ProductTariffingVolumeEnum:
      $ref: './products/enums/product_tariffing_volume_enum.yaml'
    ProductFlagEnum:
      $ref: './products/enums/product_flag_enum.yaml'
    ProductStatusTypeEnum:
      $ref: './products/enums/product_status_type_enum.yaml'
    ProductEventEnum:
      $ref: './products/enums/product_event_enum.yaml'
    EventOperationEnum:
      $ref: './products/enums/event_operation_enum.yaml'
    MetricsCategoryEnum:
      $ref: './products/enums/metrics_category_enum.yaml'
    FieldSettingsMaskEnum:
      $ref: './classifiers/enums/field_settings_mask_enum.yaml'
    ProductImportStatusEnum:
      $ref: './imports/enums/product_import_status_enum.yaml'
    ProductImportTypeEnum:
      $ref: './imports/enums/product_import_type_enum.yaml'
    BulkOperationActionTypeEnum:
      $ref: './common/enums/bulk_operation_action_enum.yaml'
    BulkOperationEntityEnum:
      $ref: './common/enums/bulk_operation_entity_enum.yaml'
    BulkOperationStatusEnum:
      $ref: './common/enums/bulk_operation_status_enum.yaml'

    EmptyDataResponse:
      type: object
      properties:
        data:
          type: object
          nullable: true
        meta:
          type: object
      required:
        - data

  responses:
    BadRequest:
      description: Bad Request
      content:
        application/json:
          schema:
            $ref: './errors.yaml#/ErrorResponse'
    NotFound:
      description: Not Found
      content:
        application/json:
          schema:
            $ref: './errors.yaml#/ErrorResponse'
    ServerError:
      description: Internal Server Error
      content:
        application/json:
          schema:
            $ref: './errors.yaml#/ErrorResponse'
    AccessDenied:
      description: Access denied
      content:
        application/json:
          schema:
            $ref: './errors.yaml#/ErrorResponse'
    Forbidden:
      description: Forbidden
      content:
        application/json:
          schema:
            $ref: './errors.yaml#/ErrorResponse'
    DeleteResponse:
      description: Delete success
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/EmptyDataResponse'
    MassOperationResultResponse:
      description: Mass operation success
      content:
        application/json:
          schema:
            $ref: './common_schemas.yaml#/MassOperationResult'
    PreloadFileResponse:
      description: File successfully loaded and saved
      content:
        application/json:
          schema:
            $ref: './common_schemas.yaml#/PreloadFile'
